//Закачка только внутренних платёжек PP, параметр cimportpppv не учитывается
/**TF_GetExtention() не вызывается. Но если она есть и вызвана, то вернёт 
* маску экспорта. 
*/
function TF_GetExtention()
{
	return "R*.???";
}
/**ReadImpFile вызывается из DpCLB.js и создаёт документы типа DpDoc.
При отсутствии ошибок возвращает true.
@param sFilePath - полный путь к файлу с платёжками.
@param Noper - номер операции для папки, в которой стоим.
@param cimportpppv - отдельно или вместе закачивать документы типов PP PV.
@param cduplic - сообщать или нет о дублирующих документах. 
*/
function ReadImpFile(sFilePath, Noper, cimportpppv, cduplic)
{
	var sFile	= String(ReadTxtFile(sFilePath,"cp1251"));
		nNewLine	= 0,
		nBlank		= 0,
		sLine		= "";

	//переменные для разбора файла
	//префиксы
	//s - sender
	//r - receiver
	var	sDocType,DOC_DAT,DOC_NUM,
		sNAME, sOKPO, sMFO, sACCOUNT,
        rNAME, rOKPO, rMFO, rACCOUNT,
        TOVAR, SUM_UAH, SUM_VAL, sDATEOP,
        mACCOUNT, sVAL, sBNKNAME, i=-1,j=-1;   	
		
	var	nIndex,sYear,sMonth,sDay,sHour,sMinut;
	
	sDocType = "PP";
	var natsVal = new Array(1,2,9,10,11,75,76,2111,2121);
	var inVal = new Array(55,56,60,70,2211,2221);
	while(sFile.length>0)
	{
		nNewLine	= sFile.indexOf('\n');
		if(-1 == nNewLine)
		{
			sLine	= sFile;
			sFile	= "";
		}
		else
		{
			sLine	= sFile.substr(0, nNewLine);
			sFile	= sFile.substr(nNewLine+1);
		}
		nIndex = sLine.indexOf('·');
		//пропускаем пустые строки и смотрим чтоб направление маршрутизации = 0
		if((sLine.length != 0) && (sLine.charAt(0)=='0'))
		{
			//Вид платёжного документа
			sLine = sLine.substr(nIndex+1);
			nIndex = sLine.indexOf('·');
			sVAL = Number(allt(sLine.substring(0,nIndex)));
			//для национальной валюты код 0, для иностранной нет пока данных соответствия кодов
			if(sVAL in natsVal)
			{
				sVAL = 0;
			}
			
			//Номер платёжного документа
			sLine = sLine.substr(nIndex+1);
			nIndex = sLine.indexOf('·');
			DOC_NUM = allt(sLine.substring(0,nIndex));
			
			//Дата выписки платёжного документа
			sLine = sLine.substr(nIndex+1);
			nIndex = sLine.indexOf('·');
			DOC_DAT = allt(sLine.substring(0,nIndex));
			sYear = DOC_DAT.substring(0,4);
			sMonth = 0+DOC_DAT.substring(4,6)-1;
			sDay = DOC_DAT.substring(6,8);
			DOC_DAT = sDay+"/"+sMonth+"/"+sYear;
			DOC_DATOBJ = Dp_DATEfromDMY(DOC_DAT);
			
			//МФО банка плательщика (наш)
			sLine = sLine.substr(nIndex+1);
			nIndex = sLine.indexOf('·');
			sMFO = allt(sLine.substring(0,nIndex));
			
			//МФО банка получателя
			sLine = sLine.substr(nIndex+1);
			nIndex = sLine.indexOf('·');
			rMFO = allt(sLine.substring(0,nIndex));
			
			//Расчетный счет плательщика
			sLine = sLine.substr(nIndex+1);
			nIndex = sLine.indexOf('·');
			sACCOUNT = allt(sLine.substring(0,nIndex));
			
			//Расчетный счет получателя
			sLine = sLine.substr(nIndex+1);
			nIndex = sLine.indexOf('·');
			rACCOUNT = allt(sLine.substring(0,nIndex));
			
			//Сумма  платежа в копейках для нац. валюты или дpобных единицах для ин.валюты
			sLine = sLine.substr(nIndex+1);
			nIndex = sLine.indexOf('·');
			SUM_UAH = allt(sLine.substring(0,nIndex));
			
			//Кассовый символ
			sLine = sLine.substr(nIndex+1);
			nIndex = sLine.indexOf('·');
			
			//Название получателя
			sLine = sLine.substr(nIndex+1);
			nIndex = sLine.indexOf('·');
			rNAME = allt(sLine.substring(0,nIndex));
			
			//Назначение платежа
			sLine = sLine.substr(nIndex+1);
			nIndex = sLine.indexOf('·');
			TOVAR = allt(sLine.substring(0,nIndex));
			var nInd = TOVAR.indexOf('070;')
			if(nInd != -1)
			{
				//Код ОКПО плательщика
				var buf = TOVAR;
				TOVAR = TOVAR.substr(nInd+4);
				nInd = TOVAR.indexOf(';');
				sOKPO = allt(TOVAR.substring(0,nInd));
				TOVAR = buf;
			}
			
			
			//Дата валютирования
			sLine = sLine.substr(nIndex+1);
			nIndex = sLine.indexOf('·');
			
			//Код вида акцепта: 1, 2, 3
			sLine = sLine.substr(nIndex+1);
			nIndex = sLine.indexOf('·');
			//Код платежа
			sLine = sLine.substr(nIndex+1);
			nIndex = sLine.indexOf('·');
			//Пpизнак пеpедачи (не используется)
			sLine = sLine.substr(nIndex+1);
			nIndex = sLine.indexOf('·');
			
			//Код ОКПО коppеспондента клиента
			sLine = sLine.substr(nIndex+1);
			nIndex = sLine.indexOf('·');
			rOKPO = allt(sLine.substring(0,nIndex));
			
			//Код валюты (только для 55,56,2211,2221) или пусто
			sLine = sLine.substr(nIndex+1);
			nIndex = sLine.indexOf('·');
			
			if(SUM_UAH == "")
				SUM_UAH	= 0;
			else
				SUM_UAH	= Number(SUM_UAH)/100;
				
			//создаём документ и устанавливаем значения его переменных
			if(DocType == sDocType)	
			{			
				var platDoc = new DpDoc(sDocType, Noper);						
				platDoc.setVar("HNOM", DOC_NUM);
				//platDoc.setVar("HTOT", sNAME);
				platDoc.setVar("HCOT", sOKPO);
				platDoc.setVar("HMFOOT", sMFO);				
				platDoc.setVar("HDBSC", sACCOUNT);					
				platDoc.setVar("HTTO", rNAME);			
				platDoc.setVar("HCTO", rOKPO);
				platDoc.setVar("HMFOTO", rMFO);			
				platDoc.setVar("HCRSC", rACCOUNT);

				platDoc.setVar("HVAL", sVAL);
				platDoc.setVar("HTOVAR", TOVAR);
				platDoc.setVar("HSUM", SUM_UAH);
				platDoc.setVar("HNDS", round((SUM_UAH/6),2));   			
				platDoc.setVar("HDAT", DOC_DATOBJ);	
				
				if (cduplic)//проверка дублей
				{
					if(platDoc.getVar("HDAT")!=null && platDoc.getVar("HNOM")!=null && platDoc.getVar("HSUM")!=null)
					{
						var sqlStr = "SELECT * from ^RAS_SCH WHERE FDOC_NUM = "
							+sqlTo(platDoc.getVar("HNOM"))+" AND FDOC_DAT = "+sqlTo(platDoc.getVar("HDAT"))
							+" AND FDOC = " + sqlTo(sDocType)
							+" AND FFCR_SC = "+sqlTo(platDoc.getVar("HCRSC"))+" AND FFDB_SC = "+sqlTo(platDoc.getVar("HDBSC"))
							+" AND FSUM = "+sqlTo(platDoc.getVar("HSUM"))+" AND FTOVAR = "+sqlTo(platDoc.getVar("HTOVAR"));
						var tdup = OpenTable("s",sqlStr);								
						if (tdup.recordCount > 0)
						{										
							alertStr1 = UR("ОБНАРУЖЕНО "+tdup.recordCount+" ДОКУМЕНТОВ С ПАРАМЕТРАМИ: НОМЕР "+allt(platDoc.getVar("HNOM"))+","
							+" ДАТA "+format("dd.mm.yyyy",tdup.getValue("FDOC_DAT"))+","
							+"\nСУММA "+platDoc.getVar("HSUM")+", ТИП ДОКУМЕНТА "+sDocType
							+"\nИ НАЗНАЧЕНИЕ ПЛАТЕЖА-"+platDoc.getVar("HTOVAR") 
							+"|ЗНАЙДЕНО "+tdup.recordCount+" ДОКУМЕНТІВ З ПАРАМЕТРАМИ: НОМЕР "+allt(platDoc.getVar("HNOM"))+","
							+" ДАТA "+format("dd.mm.yyyy",tdup.getValue("FDOC_DAT"))+","
							+"\nСУМA "+platDoc.getVar("HSUM")+", ВИД ДОКУМЕНТУ "+sDocType
							+"\nТА ПРИЗНАЧЕННЯМ ПЛАТІЖНОГО ДОКУМЕНТУ-"+allt(platDoc.getVar("HTOVAR")));
							alertStr2 = UR("ДОКУМЕНТ С ТАКИМИ САМЫМИ ПАРАМЕТРАМИ ВЫ ИМПОРТИРУЕТЕ.|ДОКУМЕНТ З ТАКИМИ САМИМИ ПАРАМЕТРАМИ ВИ ІМПОРТУЄТЕ.");
							alertStr3 = "\n\n"+UR("ИМПОРТИРОВАТЬ ДОКУМЕНТ?|ІМПОРТУВАТИ ДОКУМЕНТ?");
							alertStr = alertStr1+"\n"+alertStr2+alertStr3+tdup.getValue("FDOC_DAT");
							var bAnswer = confirm(alertStr)
							if (!bAnswer)//importirovat6
							{
								continue;
							}
						}
					}
				}											
				var HORG = 0;
				HORG = getOrgNum(platDoc.getVar("HCTO"),platDoc.getVar("HMFOTO"),platDoc.getVar("HCRSC"));//(OKPO,MFO,RSCH)
				if (HORG == null)
					HORG = 0;					
				platDoc.setVar("HORG", HORG);
				platDoc.save();	
			}
			else
			{
				alert(ru("Импорт файла ","Імпорт файлу ")+sFilePath
						+ru(" возможен только для внутренних платёжек (тип документов PP)",
						" можливий лише для внутрішніх платежів (тип документів PP)"));
				return false;
			}
		}	
	}
	return true;
}